#
# Turing -- Ruby implementation of Captcha
#
# Copyright © 2005 Michal Šafránek <wejn@box.cz>
#
# This file is part of http://turing.rubyforge.org/
#
# See turing.rb in lib/ directory for license terms.
#

# == Blending Turing test 
# Blends text with background (highly imperfect for some backgrounds).
class Turing::Image::Blending < Turing::Image # {{{
	# contract method - generate the challenge
	def generate(img, word, bg = nil) # {{{
		if bg.nil?
			possible = Dir[File.join(@options[:bgdir], '*')]
			bg = possible[rand(possible.size)]
		else
			unless FileTest.exists?(bg)
				raise ArgumentError, "Wrong background!"
			end
		end

		img_tmp = GD2::Image.load(File.open(bg, 'r'))

		if img_tmp.width < img.width || img_tmp.height < img.height
			raise "Background has insufficient dimensions"
		end

		img.copy_from(img_tmp, 0, 0, 0, 0, img.width, img.height)

		# XXX: equivalent of img_tmp.destroy ?
		img_tmp = nil

		r = rand(32)
		fg = GD2::Color[r, r, r, 40.percent]

		write_string(img, 'georgiai.ttf', fg, word, 40)

	end # }}}
end # }}}

# vim: set ts=4 sw=4 :
