#!/usr/bin/ruby
#
# Turing -- Ruby implementation of Captcha
#
# Copyright © 2005 Michal Šafránek <wejn@box.cz>
#
# This file is part of http://turing.rubyforge.org/
#
# See turing.rb in lib/ directory for license terms.
#

# This file demonstrates simple CGI challenge/response
# authenticator built using CGIHandler.
#
# It handles autonomously all requests thrown at it
# and when user successfully passes turing challenge,
# he's given cookie and redirected to some location.
#
# BTW, it would be fairly easy to convert this to FCGI.
#
# Warning: For real world please create more intelligent
# on_success handler since this one is VERY easy to bypass.

require 'rubygems'
gem 'turing'
require 'turing'

tcgi_config = {
	:imagepath => "/imgs",
	:outdir => '/home/wejn/ap/htdocs/imgs',
	:store => '/home/wejn/ap/data/turing.pstore',
	:redirect_to => 'http://localhost:8000/secured/',
}

tcgi_config[:on_success] = proc do
	out = {}
	out[:headers] = {
		"cookie" => CGI::Cookie.new({
			'name' => 'turing_passed',
			'value' => 'true',
			'path' => '/',
			'expires' => Time.now + 3600*24,
			}),
		"dude" => "you_rock!",
	}
	out
end

Turing::CGIHandler.new(tcgi_config).handle
